//BLE device

#include <advertisedDeviceCallbacks.h>



// ***** getTemperature *****
float advertisedDeviceCallbacks::getTemperature(BLEAdvertisedDevice device) {
  uint8_t temp_lb = (uint8_t) device.getManufacturerData().c_str()[1]; // temperature lower byte 
  uint8_t temp_hb = (uint8_t)(device.getManufacturerData().c_str()[2]); // temperature higher byte 
  int16_t temperature = (int16_t)((uint16_t)(temp_hb)<<8) + (uint16_t)temp_lb;
  return ((float)(temperature)/10);
}



//Display the BLE Device data
void advertisedDeviceCallbacks::onResult(BLEAdvertisedDevice device) {
    if (device.getName() == "TP358 (5551)") {
        log_debug(F("\n[CALIBRATION][advertisedDeviceCallbacks] Reference temperature : "));
        valBLE=getTemperature(device);
        log_debug(valBLE);
        log_flush();
        _gotcalibrationvalue = true;
    }else{
        log_debug(F("\n[CALIBRATION][advertisedDeviceCallbacks] This device is not a ThermoPro TP358 (5551) : "));
        log_debug(device.getName());log_flush();
    }
    
}

